@use 'sass:color';

@mixin theme() {
  $background-color: #2a2a2a;
  $text-color: #e2e2e2;
  $border-color: #0f111a;

  $color-primary: #d182ff;
  $color-blue: #82aaff;
  $color-green: #c3e88d;
  $color-red: #f07178;
  $color-orange: #ffcb6b;
  $color-mute: #5e5e5e;

  $button-color: #bbb;
  $button-background: #14151a;
  $button-color--disabled: color.adjust($button-color, $lightness: -15%);
  $button-background--disabled: color.adjust($button-background, $lightness: 10%);

  // Base colors
  --background-color: #{$background-color};
  --background-color-alt: #{color.adjust($background-color, $lightness: -2%)};
  --foreground-color: #{$text-color};
  --primary-color: #{$color-primary};

  // Borders
  --border-color: #{$border-color};
  --border-color-alt: #{color.change($border-color, $alpha: 0.3)};

  // Text selection
  --selection-background-color: #364656;
  --selection-foreground-color: #fff;

  // Overlays
  --overlay-color: rgb(0 0 0 / 90%);

  // Generic components
  --component-content-background: #{color.adjust($background-color, $lightness: -3%)};
  --component-content-background-alt: #{color.adjust($background-color, $lightness: 3%)};

  // Buttons
  --button-color: #{$button-color};
  --button-background: #{$button-background};
  --button-background--hover: #{color.adjust($button-background, $lightness: 5%)};
  --button-background--active: #{color.adjust($button-background, $lightness: 15%)};
  --button-color--disabled: #{$button-color--disabled};
  --button-background--disabled: #{$button-background--disabled};

  // Badges
  --badge-background: #333;
  --badge-color: var(--foreground-color);

  // Links
  --link-color: #{$color-primary};
  --link-color--hover: #{color.adjust($color-primary, $lightness: 10%)};

  // Loading state
  --loading-color: #{color.adjust($text-color, $lightness: -15%)};

  // Tables
  --table-background--hover: #222;

  // Forms
  // base64 --wrap=0 src/checkbox.svg
  // base64 --wrap=0 src/radio.svg
  --form-checkbox-background: url('data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHZpZXdCb3g9IjAgMCA4IDgiPjxwYXRoIGZpbGw9IiNlMmUyZTIiIGQ9Ik02LjQgMWwtLjcuNy0yLjggMi44LS44LS44LS43LS43TDAgNC40bC43LjcgMS41IDEuNS43LjcuNy0uNyAzLjUtMy41LjctLjdMNi40IDF6Ii8+PC9zdmc+Cg==');
  --form-radio-background: url('data:image/svg+xml;base64,PHN2ZyB3aWR0aD0iNDAiIGhlaWdodD0iNDAiIHZpZXdCb3g9IjAgMCA4MCA4MCIgeG1sbnM9Imh0dHA6Ly93d3cudzMub3JnLzIwMDAvc3ZnIj48Y2lyY2xlIGN4PSI0MCIgY3k9IjQwIiByPSIyNCIgZmlsbD0iI2UyZTJlMiIvPjwvc3ZnPgo=');

  // States
  --state-color-blue: #{$color-blue};
  --state-color-blue--hover: #{color.adjust($color-blue, $lightness: -10%)};
  --state-color-blue--active: #{color.adjust($color-blue, $lightness: -20%)};
  --state-color-blue-alt: #2a2a2a;
  --state-color-green: #{$color-green};
  --state-color-green--hover: #{color.adjust($color-green, $lightness: -10%)};
  --state-color-green--active: #{color.adjust($color-green, $lightness: -20%)};
  --state-color-green-alt: #2a2a2a;
  --state-color-red: #{$color-red};
  --state-color-red--hover: #{color.adjust($color-red, $lightness: -10%)};
  --state-color-red--active: #{color.adjust($color-red, $lightness: -20%)};
  --state-color-red-alt: #2a2a2a;
  --state-color-orange: #{$color-orange};
  --state-color-orange--hover: #{color.adjust($color-orange, $lightness: -10%)};
  --state-color-orange--active: #{color.adjust($color-orange, $lightness: -20%)};
  --state-color-orange-alt: #2a2a2a;
  --state-color-mute: #{$color-mute};
  --state-color-mute-alt: var(--background-color);
}
